<?php
class ControllerPaymentQuantum extends Controller {
	private $error = array();

	public function index() {
		$this->load->language('payment/quantum');

		$this->document->setTitle($this->language->get('heading_title'));

		$this->load->model('setting/setting');

		if (($this->request->server['REQUEST_METHOD'] == 'POST') && $this->validate()) {
			$this->model_setting_setting->editSetting('quantum', $this->request->post);

			$this->session->data['success'] = $this->language->get('text_success');

			$this->response->redirect($this->url->link('extension/payment', 'token=' . $this->session->data['token'], 'SSL'));
		}

		$data['heading_title'] = $this->language->get('heading_title');

		$data['text_edit'] = $this->language->get('text_edit');
		$data['text_enabled'] = $this->language->get('text_enabled');
		$data['text_disabled'] = $this->language->get('text_disabled');
		$data['text_all_zones'] = $this->language->get('text_all_zones');
		$data['text_yes'] = $this->language->get('text_yes');
		$data['text_no'] = $this->language->get('text_no');

		$data['entry_vault_key'] = $this->language->get('entry_vault_key');
		$data['entry_restrict_key'] = $this->language->get('entry_restrict_key');
		$data['entry_gwlogin'] = $this->language->get('entry_gwlogin');
		$data['entry_api_username'] = $this->language->get('entry_api_username');
		$data['entry_api_key'] = $this->language->get('entry_api_key');
		$data['entry_md5_key'] = $this->language->get('entry_md5_key');
		$data['entry_trans_type'] = $this->language->get('entry_trans_type');
		$data['entry_override_trans_email'] = $this->language->get('entry_override_trans_email');
		$data['entry_override_email_customer'] = $this->language->get('entry_override_email_customer');

		$data['entry_password'] = $this->language->get('entry_password');
		$data['entry_test'] = $this->language->get('entry_test');
		$data['entry_total'] = $this->language->get('entry_total');
		$data['entry_order_status'] = $this->language->get('entry_order_status');
		$data['entry_geo_zone'] = $this->language->get('entry_geo_zone');
		$data['entry_status'] = $this->language->get('entry_status');
		$data['entry_sort_order'] = $this->language->get('entry_sort_order');

		$data['tab_api'] = $this->language->get('entry_tab_api');
		$data['tab_general'] = $this->language->get('entry_tab_general');
		$data['tab_order_status'] = $this->language->get('entry_tab_order_status');

		$data['help_password'] = $this->language->get('help_password');
		$data['help_total'] = $this->language->get('help_total');

		$data['button_save'] = $this->language->get('button_save');
		$data['button_cancel'] = $this->language->get('button_cancel');
		$data['button_search'] = $this->language->get('button_search');

		$data['ssl_is_turned_on_in_admin'] = (bool)$this->config->get('config_secure');
		$data['text_ssl_alert_message'] = $this->language->get('text_ssl_alert_message');

		if (isset($this->error['warning'])) {
			$data['error_warning'] = $this->error['warning'];
		} else {
			$data['error_warning'] = '';
		}


		if (isset($this->error['vault_key'])) {
			$data['error_vault_key'] = $this->error['vault_key'];
		} else {
			$data['error_vault_key'] = '';
		}

		if (isset($this->error['restrict_key'])) {
			$data['error_restrict_key'] = $this->error['restrict_key'];
		} else {
			$data['error_restrict_key'] = '';
		}

		if (isset($this->error['gwlogin'])) {
			$data['error_gwlogin'] = $this->error['gwlogin'];
		} else {
			$data['error_gwlogin'] = '';
		}

		if (isset($this->error['api_username'])) {
			$data['error_api_username'] = $this->error['api_username'];
		} else {
			$data['error_api_username'] = '';
		}

		if (isset($this->error['api_key'])) {
			$data['error_api_key'] = $this->error['api_key'];
		} else {
			$data['error_api_key'] = '';
		}

		if (isset($this->error['md5_key'])) {
			$data['error_md5_key'] = $this->error['md5_key'];
		} else {
			$data['error_md5_key'] = '';
		}

		if (isset($this->error['trans_type'])) {
			$data['error_trans_type'] = $this->error['trans_type'];
		} else {
			$data['error_trans_type'] = '';
		}

		$data['breadcrumbs'][] = array(
			'text' => $this->language->get('text_home'),
			'href' => $this->url->link('common/dashboard', 'token=' . $this->session->data['token'], 'SSL')
		);

		$data['breadcrumbs'][] = array(
			'text' => $this->language->get('text_payment'),
			'href' => $this->url->link('extension/payment', 'token=' . $this->session->data['token'], 'SSL')
		);

		$data['breadcrumbs'][] = array(
			'text' => $this->language->get('heading_title'),
			'href' => $this->url->link('payment/quantum', 'token=' . $this->session->data['token'], 'SSL')
		);

		$data['action'] = $this->url->link('payment/quantum', 'token=' . $this->session->data['token'], 'SSL');
		$data['cancel'] = $this->url->link('extension/payment', 'token=' . $this->session->data['token'], 'SSL');
		$data['search'] = $this->url->link('payment/quantum/search', 'token=' . $this->session->data['token'], 'SSL');


		if (isset($this->request->post['quantum_vault_key'])) {
			$data['quantum_vault_key'] = $this->request->post['quantum_vault_key'];
		} else {
			$data['quantum_vault_key'] = $this->config->get('quantum_vault_key');
		}

		if (isset($this->request->post['quantum_restrict_key'])) {
			$data['quantum_restrict_key'] = $this->request->post['quantum_restrict_key'];
		} else {
			$data['quantum_restrict_key'] = $this->config->get('quantum_restrict_key');
		}

		if (isset($this->request->post['quantum_gwlogin'])) {
			$data['quantum_gwlogin'] = $this->request->post['quantum_gwlogin'];
		} else {
			$data['quantum_gwlogin'] = $this->config->get('quantum_gwlogin');
		}

		if (isset($this->request->post['quantum_api_username'])) {
			$data['quantum_api_username'] = $this->request->post['quantum_api_username'];
		} else {
			$data['quantum_api_username'] = $this->config->get('quantum_api_username');
		}

		if (isset($this->request->post['quantum_api_key'])) {
			$data['quantum_api_key'] = $this->request->post['quantum_api_key'];
		} else {
			$data['quantum_api_key'] = $this->config->get('quantum_api_key');
		}

		if (isset($this->request->post['quantum_md5_key'])) {
			$data['quantum_md5_key'] = $this->request->post['quantum_md5_key'];
		} elseif ($this->config->get('quantum_password')) {
			$data['quantum_password'] = $this->config->get('quantum_password');
		} else {
			$data['quantum_md5_key'] = $this->config->get('quantum_md5_key');
		}

		$data['trans_types'] = array(
			'AUTH_ONLY' => 'Auth Only',
			'AUTH_CAPTURE' => 'Auth Capture',
			'SALES' => 'Sales'
		);

		if (isset($this->request->post['quantum_trans_type'])) {
			$data['quantum_trans_type'] = $this->request->post['quantum_trans_type'];
		} else {
			$data['quantum_trans_type'] = $this->config->get('quantum_trans_type');
		}

		$data['override_trans_email_choices'] = array(
			'Y' => 'Yes',
			'N' => 'No'
		);

		if (isset($this->request->post['quantum_override_trans_email'])) {
			$data['quantum_override_trans_email'] = $this->request->post['quantum_override_trans_email'];
		} else {
			$data['quantum_override_trans_email'] = $this->config->get('quantum_override_trans_email');
		}

		if (isset($this->request->post['quantum_override_email_customer'])) {
			$data['quantum_override_email_customer'] = $this->request->post['quantum_override_email_customer'];
		} else {
			$data['quantum_override_email_customer'] = $this->config->get('quantum_override_email_customer');
		}

		if (isset($this->request->post['quantum_test'])) {
			$data['quantum_test'] = $this->request->post['quantum_test'];
		} else {
			$data['quantum_test'] = $this->config->get('quantum_test');
		}

		if (isset($this->request->post['quantum_total'])) {
			$data['quantum_total'] = $this->request->post['quantum_total'];
		} else {
			$data['quantum_total'] = $this->config->get('quantum_total');
		}

		if (isset($this->request->post['quantum_order_status_id'])) {
			$data['quantum_order_status_id'] = $this->request->post['quantum_order_status_id'];
		} else {
			$data['quantum_order_status_id'] = $this->config->get('quantum_order_status_id');
		}

		$this->load->model('localisation/order_status');

		$data['order_statuses'] = $this->model_localisation_order_status->getOrderStatuses();

		if (isset($this->request->post['quantum_geo_zone_id'])) {
			$data['quantum_geo_zone_id'] = $this->request->post['quantum_geo_zone_id'];
		} else {
			$data['quantum_geo_zone_id'] = $this->config->get('quantum_geo_zone_id');
		}

		$this->load->model('localisation/geo_zone');

		$data['geo_zones'] = $this->model_localisation_geo_zone->getGeoZones();

		if (isset($this->request->post['quantum_status'])) {
			$data['quantum_status'] = $this->request->post['quantum_status'];
		} else {
			$data['quantum_status'] = $this->config->get('quantum_status');
		}

		if (isset($this->request->post['quantum_sort_order'])) {
			$data['quantum_sort_order'] = $this->request->post['quantum_sort_order'];
		} else {
			$data['quantum_sort_order'] = $this->config->get('quantum_sort_order');
		}

		$data['header'] = $this->load->controller('common/header');
		$data['column_left'] = $this->load->controller('common/column_left');
		$data['footer'] = $this->load->controller('common/footer');

		$this->response->setOutput($this->load->view('payment/quantum.tpl', $data));
	}

	protected function validate() {
		if (!$this->user->hasPermission('modify', 'payment/quantum')) {
			$this->error['warning'] = $this->language->get('error_permission');
		}

		if (!$this->request->post['quantum_vault_key']) {
			$this->error['vault_key'] = $this->language->get('error_vault_key');
		}

		if (!$this->request->post['quantum_restrict_key']) {
			$this->error['restrict_key'] = $this->language->get('error_restrict_key');
		}

		if (!$this->request->post['quantum_gwlogin']) {
			$this->error['gwlogin'] = $this->language->get('error_gwlogin');
		}

		if (!$this->request->post['quantum_api_username']) {
			$this->error['api_username'] = $this->language->get('error_api_username');
		}

		if (!$this->request->post['quantum_api_key']) {
			$this->error['api_key'] = $this->language->get('error_api_key');
		}

		if (!$this->request->post['quantum_md5_key']) {
			$this->error['md5_key'] = $this->language->get('error_md5_key');
		}

		return !$this->error;
	}

	public function search() {
		$this->load->language('payment/quantum_search');
		$this->load->model('payment/quantum');

		$this->document->setTitle($this->language->get('heading_title'));

		$data['heading_title'] = $this->language->get('heading_title');
		$data['button_search'] = $this->language->get('button_search');
		$data['button_edit'] = $this->language->get('button_edit');
		$data['entry_date'] = $this->language->get('entry_date');
		$data['entry_date_start'] = $this->language->get('entry_date_start');
		$data['entry_date_end'] = $this->language->get('entry_date_end');
		$data['entry_status'] = $this->language->get('entry_status');
		$data['entry_debit'] = $this->language->get('entry_debit');
		$data['entry_credit'] = $this->language->get('entry_credit');
		$data['entry_return'] = $this->language->get('entry_return');
		$data['entry_date_to'] = $this->language->get('entry_date_to');
		$data['entry_transaction'] = $this->language->get('entry_transaction');
		$data['entry_transaction_type'] = $this->language->get('entry_transaction_type');
		$data['entry_transaction_status'] = $this->language->get('entry_transaction_status');
		$data['entry_email'] = $this->language->get('entry_email');
		$data['entry_email_buyer'] = $this->language->get('entry_email_buyer');
		$data['entry_email_merchant'] = $this->language->get('entry_email_merchant');
		$data['entry_receipt'] = $this->language->get('entry_receipt');
		$data['entry_transaction_id'] = $this->language->get('entry_transaction_id');
		$data['entry_invoice_no'] = $this->language->get('entry_invoice_no');
		$data['entry_auction'] = $this->language->get('entry_auction');
		$data['entry_amount'] = $this->language->get('entry_amount');
		$data['entry_recurring_id'] = $this->language->get('entry_recurring_id');
		$data['text_buyer_info'] = $this->language->get('text_buyer_info');
		$data['entry_salutation'] = $this->language->get('entry_salutation');
		$data['text_name'] = $this->language->get('text_name');
		$data['entry_firstname'] = $this->language->get('entry_firstname');
		$data['entry_middlename'] = $this->language->get('entry_middlename');
		$data['entry_lastname'] = $this->language->get('entry_lastname');
		$data['entry_suffix'] = $this->language->get('entry_suffix');
		$data['text_searching'] = $this->language->get('text_searching');
		$data['text_view'] = $this->language->get('text_view');
		$data['text_format'] = $this->language->get('text_format');
		$data['text_date_search'] = $this->language->get('text_date_search');
		$data['text_no_results'] = $this->language->get('text_no_results');
		$data['text_dates_note'] = $this->language->get('text_dates_note');

		$data['entry_status_all'] = $this->language->get('entry_status_all');
		$data['entry_status_pending'] = $this->language->get('entry_status_pending');
		$data['entry_status_processing'] = $this->language->get('entry_status_processing');
		$data['entry_status_success'] = $this->language->get('entry_status_success');
		$data['entry_status_denied'] = $this->language->get('entry_status_denied');
		$data['entry_status_reversed'] = $this->language->get('entry_status_reversed');

		$data['entry_trans_all'] = $this->language->get('entry_trans_all');
		$data['entry_trans_sent'] = $this->language->get('entry_trans_sent');
		$data['entry_trans_received'] = $this->language->get('entry_trans_received');
		$data['entry_trans_masspay'] = $this->language->get('entry_trans_masspay');
		$data['entry_trans_money_req'] = $this->language->get('entry_trans_money_req');
		$data['entry_trans_funds_add'] = $this->language->get('entry_trans_funds_add');
		$data['entry_trans_funds_with'] = $this->language->get('entry_trans_funds_with');
		$data['entry_trans_referral'] = $this->language->get('entry_trans_referral');
		$data['entry_trans_fee'] = $this->language->get('entry_trans_fee');
		$data['entry_trans_subscription'] = $this->language->get('entry_trans_subscription');
		$data['entry_trans_dividend'] = $this->language->get('entry_trans_dividend');
		$data['entry_trans_billpay'] = $this->language->get('entry_trans_billpay');
		$data['entry_trans_refund'] = $this->language->get('entry_trans_refund');
		$data['entry_trans_conv'] = $this->language->get('entry_trans_conv');
		$data['entry_trans_bal_trans'] = $this->language->get('entry_trans_bal_trans');
		$data['entry_trans_reversal'] = $this->language->get('entry_trans_reversal');
		$data['entry_trans_shipping'] = $this->language->get('entry_trans_shipping');
		$data['entry_trans_bal_affect'] = $this->language->get('entry_trans_bal_affect');
		$data['entry_trans_echeque'] = $this->language->get('entry_trans_echeque');

		$data['tbl_column_date'] = $this->language->get('tbl_column_date');
		$data['tbl_column_type'] = $this->language->get('tbl_column_type');
		$data['tbl_column_email'] = $this->language->get('tbl_column_email');
		$data['tbl_column_name'] = $this->language->get('tbl_column_name');
		$data['tbl_column_transid'] = $this->language->get('tbl_column_transid');
		$data['tbl_column_status'] = $this->language->get('tbl_column_status');
		$data['tbl_column_currency'] = $this->language->get('tbl_column_currency');
		$data['tbl_column_amount'] = $this->language->get('tbl_column_amount');
		$data['tbl_column_fee'] = $this->language->get('tbl_column_fee');
		$data['tbl_column_netamt'] = $this->language->get('tbl_column_netamt');
		$data['tbl_column_action'] = $this->language->get('tbl_column_action');
		$data['tbl_column_time'] = $this->language->get('tbl_column_time');
		$data['tbl_column_trans_type'] = $this->language->get('tbl_column_trans_type');
		$data['tbl_column_memo'] = $this->language->get('tbl_column_memo');
		$data['tbl_column_ach_status'] = $this->language->get('tbl_column_ach_status');
		$data['tbl_column_ach_status_desc'] = $this->language->get('tbl_column_ach_status_desc');
		$data['tbl_column_ach_trans_id'] = $this->language->get('tbl_column_ach_trans_id');
		$data['tbl_column_cust_id'] = $this->language->get('tbl_column_cust_id');
		$data['tbl_column_payment_type'] = $this->language->get('tbl_column_payment_type');
		$data['tbl_column_settlement_id'] = $this->language->get('tbl_column_settlement_id');
		$data['tbl_column_settlement_date'] = $this->language->get('tbl_column_settlement_date');

		$data['breadcrumbs'] = array();

		$data['breadcrumbs'][] = array(
			'text'      => $this->language->get('text_home'),
			'href'      => $this->url->link('common/home', 'token=' . $this->session->data['token'], 'SSL'),
		);

		$data['breadcrumbs'][] = array(
			'text'      => $this->language->get('text_quantum'),
			'href'      => $this->url->link('payment/quantum', 'token=' . $this->session->data['token'], 'SSL'),
		);

		$data['breadcrumbs'][] = array(
			'text'      => $this->language->get('heading_title'),
			'href'      => $this->url->link('payment/quantum/search', 'token=' . $this->session->data['token'], 'SSL'),
		);

		$data['token'] = $this->session->data['token'];
		$data['date_start'] = date("Y-m-d", strtotime('-30 days'));
		$data['date_end'] = date("Y-m-d");
		$data['view_link'] = $this->url->link('payment/quantum/viewTransaction', 'token=' . $this->session->data['token'], 'SSL');

		$data['header'] = $this->load->controller('common/header');
		$data['column_left'] = $this->load->controller('common/column_left');
		$data['footer'] = $this->load->controller('common/footer');

		$this->response->setOutput($this->load->view('payment/quantum_search.tpl', $data));
	}

	public function doSearch() {
		if (isset($this->request->post['date_start'])) {

			$this->load->model('payment/quantum');

			$call_data = array();

			$call_data['date_begin'] = gmdate($this->request->post['date_start']);

			if (!empty($this->request->post['date_end'])) {
				$call_data['date_end'] = gmdate($this->request->post['date_end']);
			} else {
				$call_data['date_end'] = '';
			}

			if (!empty($this->request->post['transaction_type'])) {
				$call_data['transaction_type'] = $this->request->post['transaction_type'];
			}
			if ($call_data['transaction_type'] === 'ALL') {
				$call_data['transaction_type'] = '';
			}

			if (!empty($this->request->post['status'])) {
				$call_data['status'] = $this->request->post['status'];
			}
			if ($call_data['status'] === 'ALL') {
				$call_data['status'] = '';
			}

			if (!empty($this->request->post['customer_id'])) {
				$call_data['customer_id'] = $this->request->post['customer_id'];
			}

			if (!empty($this->request->post['payment_type'])) {
				$call_data['payment_type'] = $this->request->post['payment_type'];
			}

			if (!empty($this->request->post['settlement_batch_id'])) {
				$call_data['settlement_batch_id'] = $this->request->post['settlement_batch_id'];
			}

			if (!empty($this->request->post['settlement_date_begin'])) {
				$call_data['settlement_date_begin'] = $this->request->post['settlement_date_begin'];
			}

			if (!empty($this->request->post['settlement_date_end'])) {
				$call_data['settlement_date_end'] = $this->request->post['settlement_date_end'];
			}

			$result = $this->model_payment_quantum->getTransactions($call_data);

			$this->response->addHeader('Content-Type: application/json');
			$this->response->setOutput($result);
		} else {
			$response['error'] = true;
			$response['error_msg'] = 'Enter a start date';
			$this->response->addHeader('Content-Type: application/json');
			$this->response->setOutput(json_encode($response));
		}
	}

	public function viewTransaction() {
		$this->load->model('payment/quantum');
		$this->load->language('payment/quantum_view');

		$data['action_status'] = isset($_GET['status']) ? $this->request->get['status'] : false;
		$data['action_status_desc'] = isset($_GET['status_description']) ? $this->request->get['status_description'] : false;
		$data['alert_type'] = 'info';
		if ($data['action_status'] == 'ERROR') {
			$data['alert_type'] = 'danger';
		}
		if ($data['action_status'] == 'Success') {
			$data['alert_type'] = 'success';
		}

		$data['transaction'] = $this->model_payment_quantum->getTransaction($this->request->get['transaction_id'], array('format' => 'array'));
		$data['lines'] = $data['transaction']['Result'];
		foreach ($data['lines'] as $key => $value) {
			if (is_array($value)) {
				$data['lines'][$key] = '&mdash;';
			}
		}
		$data['view_link'] = $this->url->link('payment/quantum/viewTransaction', 'token=' . $this->session->data['token'], 'SSL');
		$data['void_link'] = $this->url->link('payment/quantum/voidTransaction', 'token=' . $this->session->data['token'], 'SSL');
		$data['force_auth_link'] = $this->url->link('payment/quantum/forceAuthTransaction', 'token=' . $this->session->data['token'], 'SSL');
		$data['return_link'] = $this->url->link('payment/quantum/returnTransaction', 'token=' . $this->session->data['token'], 'SSL');
		$data['cancel'] = $this->url->link('payment/quantum/search', 'token=' . $this->session->data['token'], 'SSL');
		$data['token'] = $this->session->data['token'];

		$this->document->setTitle($this->language->get('heading_title'));

		$data['heading_title'] = $this->language->get('heading_title');
		$data['button_cancel'] = $this->language->get('button_cancel');
		$data['text_transaction_id'] = $this->language->get('text_transaction_id');
		$data['text_transaction_type'] = $this->language->get('text_transaction_type');
		$data['text_transaction_date'] = $this->language->get('text_transaction_date');
		$data['text_status'] = $this->language->get('text_status');
		$data['text_status_desc'] = $this->language->get('text_status_desc');
		$data['text_ach_transaction_id'] = $this->language->get('text_ach_transaction_id');
		$data['text_ach_status'] = $this->language->get('text_ach_status');
		$data['text_ach_status_desc'] = $this->language->get('text_ach_status_desc');
		$data['text_process_type'] = $this->language->get('text_process_type');
		$data['text_amount'] = $this->language->get('text_amount');
		$data['text_customer_id'] = $this->language->get('text_customer_id');
		$data['text_first_name'] = $this->language->get('text_first_name');
		$data['text_last_name'] = $this->language->get('text_last_name');
		$data['text_address'] = $this->language->get('text_address');
		$data['text_zip_code'] = $this->language->get('text_zip_code');
		$data['text_email'] = $this->language->get('text_email');
		$data['text_memo'] = $this->language->get('text_memo');
		$data['text_payment_type'] = $this->language->get('text_payment_type');
		$data['text_card_type'] = $this->language->get('text_card_type');
		$data['text_credit_card_number'] = $this->language->get('text_credit_card_number');
		$data['text_expire_month'] = $this->language->get('text_expire_month');
		$data['text_expire_year'] = $this->language->get('text_expire_year');
		$data['text_aba_number'] = $this->language->get('text_aba_number');
		$data['text_account_number'] = $this->language->get('text_account_number');
		$data['text_settlement_batch_id'] = $this->language->get('text_settlement_batch_id');
		$data['text_settlement_date'] = $this->language->get('text_settlement_date');
		$data['text_batched_out'] = $this->language->get('text_batched_out');
		$data['text_authorization_code'] = $this->language->get('text_authorization_code');
		$data['text_cvv2_response_code'] = $this->language->get('text_cvv2_response_code');
		$data['text_avs_response_code'] = $this->language->get('text_avs_response_code');
		$data['text_ship_first_name'] = $this->language->get('text_ship_first_name');
		$data['text_ship_last_name'] = $this->language->get('text_ship_last_name');
		$data['text_ship_address'] = $this->language->get('text_ship_address');
		$data['text_ship_city'] = $this->language->get('text_ship_city');
		$data['text_ship_state'] = $this->language->get('text_ship_state');
		$data['text_ship_zip_1'] = $this->language->get('text_ship_zip_1');
		$data['text_ship_country'] = $this->language->get('text_ship_country');


		$data['breadcrumbs'] = array();

		$data['breadcrumbs'][] = array(
			'text'      => $this->language->get('text_home'),
			'href'      => $this->url->link('common/home', 'token=' . $this->session->data['token'], 'SSL'),
		);

		$data['breadcrumbs'][] = array(
			'text'      => $this->language->get('text_quantum'),
			'href'      => $this->url->link('payment/quantum', 'token=' . $this->session->data['token'], 'SSL'),
		);

		$data['breadcrumbs'][] = array(
			'text'      => $this->language->get('heading_title'),
			'href'      => $this->url->link('payment/quantum/viewTransaction', 'token=' . $this->session->data['token'] . '&transaction_id=' . $this->request->get['transaction_id'], 'SSL'),
		);

		$data['header'] = $this->load->controller('common/header');
		$data['column_left'] = $this->load->controller('common/column_left');
		$data['footer'] = $this->load->controller('common/footer');

		$this->response->setOutput($this->load->view('payment/quantum_view.tpl', $data));
	}

	public function voidTransaction() {
		$transaction_id = $this->request->post['transaction_id'];
		$this->load->model('payment/quantum');
		$result = $this->model_payment_quantum->void($transaction_id);

		if ($result['ResponseSummary']) {
			$status = $result['ResponseSummary']['Status'];
			$status_desc = $result['ResponseSummary']['StatusDescription'];
			$this->response->redirect($this->url->link('payment/quantum/viewTransaction', 'token=' . $this->session->data['token'] . '&transaction_id=' . $transaction_id . '&status=' . $status . '&status_description=' . $status_desc, 'SSL'));
		} else {
			$this->response->redirect($this->url->link('payment/quantum/viewTransaction', 'token=' . $this->session->data['token'] . '&transaction_id=' . $transaction_id, 'SSL'));
		}
	}

	public function forceAuthTransaction() {
		$transaction_id = $this->request->post['transaction_id'];
		$this->load->model('payment/quantum');
		$result = $this->model_payment_quantum->forceAuth($transaction_id);

		if ($result['ResponseSummary']) {
			$status = $result['ResponseSummary']['Status'];
			$status_desc = $result['ResponseSummary']['StatusDescription'];
			$this->response->redirect($this->url->link('payment/quantum/viewTransaction', 'token=' . $this->session->data['token'] . '&transaction_id=' . $transaction_id . '&status=' . $status . '&status_description=' . $status_desc, 'SSL'));
		} else {
			$this->response->redirect($this->url->link('payment/quantum/viewTransaction', 'token=' . $this->session->data['token'] . '&transaction_id=' . $transaction_id, 'SSL'));
		}
	}

	public function returnTransaction() {
		$transaction_id = $this->request->post['transaction_id'];
		$credit_card_number = $this->request->post['credit_card_number'];
		$this->load->model('payment/quantum');
		$result = $this->model_payment_quantum->returnTransaction($transaction_id, $credit_card_number);

		if ($result['ResponseSummary']) {
			$status = $result['ResponseSummary']['Status'];
			$status_desc = $result['ResponseSummary']['StatusDescription'];
			$this->response->redirect($this->url->link('payment/quantum/viewTransaction', 'token=' . $this->session->data['token'] . '&transaction_id=' . $transaction_id . '&status=' . $status . '&status_description=' . $status_desc, 'SSL'));
		} else {
			$this->response->redirect($this->url->link('payment/quantum/viewTransaction', 'token=' . $this->session->data['token'] . '&transaction_id=' . $transaction_id, 'SSL'));
		}
	}

	public function install() {
		$this->load->model('payment/quantum');

		$this->model_payment_quantum->install();
	}

	public function uninstall() {
		$this->load->model('payment/quantum');

		$this->model_payment_quantum->uninstall();
	}
}
