<?php echo $header; ?><?php echo $column_left; ?>
<div id="content">
	<div class="page-header">
		<div class="container-fluid">
			<div class="pull-right">
				<button type="submit" form="form-quantum" data-toggle="tooltip" title="<?php echo $button_save; ?>" class="btn btn-primary"><i class="fa fa-save"></i></button>
				<a href="<?php echo $cancel; ?>" data-toggle="tooltip" title="<?php echo $button_cancel; ?>" class="btn btn-default"><i class="fa fa-reply"></i></a> <a href="<?php echo $search; ?>" data-toggle="tooltip" title="<?php echo $button_search; ?>" class="btn btn-info"><i class="fa fa-search"></i></a></div>
			<h1><?php echo $heading_title; ?></h1>
			<ul class="breadcrumb">
				<?php foreach ($breadcrumbs as $breadcrumb) { ?>
					<li><a href="<?php echo $breadcrumb['href']; ?>"><?php echo $breadcrumb['text']; ?></a></li>
				<?php } ?>
			</ul>
		</div>
	</div>
	<div class="container-fluid">
		<?php if ($error_warning) { ?>
			<div class="alert alert-danger"><i class="fa fa-exclamation-circle"></i> <?php echo $error_warning; ?>
				<button type="button" class="close" data-dismiss="alert">&times;</button>
			</div>
		<?php } ?>
		<div class="panel panel-default">
			<div class="panel-heading">
				<h3 class="panel-title"><i class="fa fa-pencil"></i> <?php echo $text_edit; ?></h3>
			</div>
			<div class="panel-body">
				<?php if (!$ssl_is_turned_on_in_admin) : ?>
					<div class="alert alert-danger"><?php echo $text_ssl_alert_message; ?></div>
				<?php endif; ?>
				<form action="<?php echo $action; ?>" method="post" enctype="multipart/form-data" id="form-quantum" class="form-horizontal">
					<ul class="nav nav-tabs">
						<li class="active"><a href="#tab-api" data-toggle="tab"><?php echo $tab_api; ?></a></li>
						<li><a href="#tab-general" data-toggle="tab"><?php echo $tab_general; ?></a></li>
						<li><a href="#tab-order-status" data-toggle="tab"><?php echo $tab_order_status; ?></a></li>
					</ul>
					<div class="tab-content">
						<div class="tab-pane active" id="tab-api">
							<div class="form-group required">
								<label class="col-sm-2 control-label" for="input-vault-key"><?php echo $entry_vault_key; ?></label>
								<div class="col-sm-10">
									<input type="text" name="quantum_vault_key" value="<?php echo $quantum_vault_key; ?>" placeholder="<?php echo $entry_vault_key; ?>" id="input-vault-key" class="form-control" />
									<?php if ($error_vault_key) { ?>
										<div class="text-danger"><?php echo $error_vault_key; ?></div>
									<?php } ?>
								</div>
							</div>
							<div class="form-group required">
								<label class="col-sm-2 control-label" for="input-restrict-key"><?php echo $entry_restrict_key; ?></label>
								<div class="col-sm-10">
									<input type="text" name="quantum_restrict_key" value="<?php echo $quantum_restrict_key; ?>" placeholder="<?php echo $entry_restrict_key; ?>" id="input-restrict-key" class="form-control" />
									<?php if ($error_restrict_key) { ?>
										<div class="text-danger"><?php echo $error_restrict_key; ?></div>
									<?php } ?>
								</div>
							</div>
							<div class="form-group required">
								<label class="col-sm-2 control-label" for="input-gwlogin"><?php echo $entry_gwlogin; ?></label>
								<div class="col-sm-10">
									<input type="text" name="quantum_gwlogin" value="<?php echo $quantum_gwlogin; ?>" placeholder="<?php echo $entry_gwlogin; ?>" id="input-gwlogin" class="form-control" />
									<?php if ($error_gwlogin) { ?>
										<div class="text-danger"><?php echo $error_gwlogin; ?></div>
									<?php } ?>
								</div>
							</div>
							<div class="form-group required">
								<label class="col-sm-2 control-label" for="input-api-username"><?php echo $entry_api_username; ?></label>
								<div class="col-sm-10">
									<input type="text" name="quantum_api_username" value="<?php echo $quantum_api_username; ?>" placeholder="<?php echo $entry_api_username; ?>" id="input-api-username" class="form-control" />
									<?php if ($error_api_username) { ?>
										<div class="text-danger"><?php echo $error_api_username; ?></div>
									<?php } ?>
								</div>
							</div>
							<div class="form-group required">
								<label class="col-sm-2 control-label" for="input-api-key"><?php echo $entry_api_key; ?></label>
								<div class="col-sm-10">
									<input type="text" name="quantum_api_key" value="<?php echo $quantum_api_key; ?>" placeholder="<?php echo $entry_api_key; ?>" id="input-api-key" class="form-control" />
									<?php if ($error_api_key) { ?>
										<div class="text-danger"><?php echo $error_api_key; ?></div>
									<?php } ?>
								</div>
							</div>
							<div class="form-group required">
								<label class="col-sm-2 control-label" for="input-md5-key"><?php echo $entry_md5_key; ?></label>
								<div class="col-sm-10">
									<input type="text" name="quantum_md5_key" value="<?php echo $quantum_md5_key; ?>" placeholder="<?php echo $entry_md5_key; ?>" id="input-md5-key" class="form-control" />
									<?php if ($error_md5_key) { ?>
										<div class="text-danger"><?php echo $error_md5_key; ?></div>
									<?php } ?>
								</div>
							</div>
						</div>

						<div class="tab-pane" id="tab-general">
							<div class="form-group">
								<label class="col-sm-2 control-label" for="input-trans-type"><?php echo $entry_trans_type; ?></label>
								<div class="col-sm-10">
									<select name="quantum_trans_type" id="input-trans-type" class="form-control">
										<?php foreach ($trans_types as $trans_type_key => $trans_type_value) { ?>
											<?php if ($trans_type_key == $quantum_trans_type) { ?>
												<option value="<?php echo $trans_type_key; ?>" selected="selected"><?php echo $trans_type_value; ?></option>
											<?php } else { ?>
												<option value="<?php echo $trans_type_key; ?>"><?php echo $trans_type_value; ?></option>
											<?php } ?>
										<?php } ?>
									</select>
								</div>
							</div>
							<div class="form-group">
								<label class="col-sm-2 control-label" for="input-override-trans-email"><?php echo $entry_override_trans_email; ?></label>
								<div class="col-sm-10">
									<select name="quantum_override_trans_email" id="input-override-trans-email" class="form-control">
										<?php foreach ($override_trans_email_choices as $key => $value) { ?>
											<?php if ($key == $quantum_override_trans_email) { ?>
												<option value="<?php echo $key; ?>" selected="selected"><?php echo $value; ?></option>
											<?php } else { ?>
												<option value="<?php echo $key; ?>"><?php echo $value; ?></option>
											<?php } ?>
										<?php } ?>
									</select>
								</div>
							</div>
							<div class="form-group">
								<label class="col-sm-2 control-label" for="input-override-customer-email"><?php echo $entry_override_email_customer; ?></label>
								<div class="col-sm-10">
									<select name="quantum_override_email_customer" id="input-override-customer-email" class="form-control">
										<?php foreach ($override_trans_email_choices as $key => $value) { ?>
											<?php if ($key == $quantum_override_email_customer) { ?>
												<option value="<?php echo $key; ?>" selected="selected"><?php echo $value; ?></option>
											<?php } else { ?>
												<option value="<?php echo $key; ?>"><?php echo $value; ?></option>
											<?php } ?>
										<?php } ?>
									</select>
								</div>
							</div>
							<div class="form-group">
								<label class="col-sm-2 control-label" for="input-status"><?php echo $entry_status; ?></label>
								<div class="col-sm-10">
									<select name="quantum_status" id="input-status" class="form-control">
										<?php if ($quantum_status) { ?>
											<option value="1" selected="selected"><?php echo $text_enabled; ?></option>
											<option value="0"><?php echo $text_disabled; ?></option>
										<?php } else { ?>
											<option value="1"><?php echo $text_enabled; ?></option>
											<option value="0" selected="selected"><?php echo $text_disabled; ?></option>
										<?php } ?>
									</select>
								</div>
							</div>
						</div>

						<div class="tab-pane" id="tab-order-status">

						</div>

					</div>
				</form>
			</div>
		</div>
	</div>
</div>
<?php echo $footer; ?>
