<?php
class ModelPaymentQuantum extends Model {
	public function getMethod($address, $total) {
		$this->load->language('payment/quantum');

		$query = $this->db->query("SELECT * FROM " . DB_PREFIX . "zone_to_geo_zone WHERE geo_zone_id = '" . (int)$this->config->get('quantum_geo_zone_id') . "' AND country_id = '" . (int)$address['country_id'] . "' AND (zone_id = '" . (int)$address['zone_id'] . "' OR zone_id = '0')");

		if ($this->config->get('quantum_total') > 0 && $this->config->get('quantum_total') > $total) {
			$status = false;
		} elseif (!$this->config->get('quantum_geo_zone_id')) {
			$status = true;
		} elseif ($query->num_rows) {
			$status = true;
		} else {
			$status = false;
		}

		$method_data = array();

		if ($status) {
			$method_data = array(
				'code'       => 'quantum',
				'title'      => $this->language->get('text_title'),
				'terms'      => '',
				'sort_order' => $this->config->get('quantum_sort_order')
			);
		}

		return $method_data;
	}

	public function addOrder($order_data) {
		$this->db->query("INSERT INTO `" . DB_PREFIX . "quantum_order` SET"
		                 . " `order_id` = '" . (int)$order_data['order_id']
		                 . "', `date_added` = NOW(), `date_modified` = NOW()");

		return $this->db->getLastId();
	}

	public function addTransaction($transaction_data) {
		$this->db->query("INSERT INTO `" . DB_PREFIX . "quantum_order_transaction` SET"
		                 . " `quantum_order_id` = '" . (int)$transaction_data['quantum_order_id']
		                 . "', `transaction_id` = '" . $this->db->escape($transaction_data['transaction_id'])
		                 . "', `date_added` = NOW()"
		                 . ", `trans_result` = '" . $this->db->escape($transaction_data['trans_result'])
		                 . "', `trans_type` = '" . $this->db->escape($transaction_data['trans_type'])
		                 . "', `amount` = '" . (float)$transaction_data['amount']
		                 . "', `customer_id` = '" . (float)$transaction_data['customer_id']
		                 . "', `md5_hash` = '" . (float)$transaction_data['md5_hash']
		                 . "', `avs` = '" . (float)$transaction_data['avs']
		                 . "', `cvv2` = '" . (float)$transaction_data['cvv2']
		                 . "', `last_4cc` = '" . (float)$transaction_data['last_4cc']
		                 . "', `auth_code` = '" . (float)$transaction_data['auth_code']
		                 ."'");
	}

	public function addCustomer( $customer_id ) {
		$this->db->query("INSERT INTO `" . DB_PREFIX . "quantum_customer` SET"
		                 . " `customer_id` = '" . (int)$customer_id
		                 . "', `date_added` = NOW()");

		return $this->db->getLastId();
	}

	public function getCustomer( $customer_id ) {
		$qry = $this->db->query("SELECT * FROM `" . DB_PREFIX . "quantum_customer` WHERE `customer_id` = '" . (int)$customer_id . "' LIMIT 1");

		if ($qry->num_rows) {
			$customer = $qry->row;
			return $customer['quantum_customer_id'];
		} else {
			return false;
		}
	}

	public function authenticate() {

		$path = "/cgi/ilf_authenticate.php";
		$host = "secure.quantumgateway.com";

		$data = array(
			"API_Username" => $this->config->get('quantum_api_username'),
			"API_Key" => $this->config->get('quantum_api_key'),
			"randval" => (int)rand(1111111111, 9999999999),
			"lastip" => $_SERVER['REMOTE_ADDR']
		);

		$req = $this->_quantumilf_qsencode($data);
		$response = '';
		if ( (PHP_VERSION >= 4.3) && ($fs = @fsockopen('ssl://secure.quantumgateway.com', 443, $errno, $errstr, 30)) ) {

			$http_request  = "POST $path HTTP/1.0\r\n";
			$http_request .= "Host: $host\r\n";
			$http_request .= "Content-Type: application/x-www-form-urlencoded;\r\n";
			$http_request .= "Content-Length: " . strlen($req) . "\r\n";
			$agent = "Mozilla/5.0 (Windows NT 6.1; WOW64; rv:34.0) Gecko/20100101 Firefox/34.0";
			$http_request .= "User-Agent: $agent\r\n";
			$http_request .= "\r\n";
			$http_request .= $req;

			fwrite($fs, $http_request);
			while (!feof($fs)) {
				$response .= fgets($fs, 1160); // One TCP-IP packet
			}

			fclose($fs);
			$response = explode("\r\n\r\n", $response, 2);
		} elseif (function_exists('curl_exec')) {

			$ch = curl_init();
			$curl_url = 'https://secure.quantumgateway.com' . $path;
			curl_setopt($ch, CURLOPT_URL, $curl_url);
			curl_setopt($ch, CURLOPT_POST, true);
			curl_setopt($ch, CURLOPT_POSTFIELDS, $req);
			curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
			curl_setopt($ch, CURLOPT_HEADER, false);
			curl_setopt($ch, CURLOPT_TIMEOUT, 30);
			curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, false);

			$result = curl_exec($ch);
			$response = explode("\r\n\r\n", $result, 2);
			$response[1] = $response[0];
			curl_close($ch);


		}

		$json = array(
			"error" => true
		);

		if (is_array($response)) {
			if ($response[1] !== 'error') {
				$json['error'] = false;
				$json['key'] = $response[1];
			}
		}

		return $json;
	}

	private function _quantumilf_qsencode($data) {
		$req = "";
		foreach ( $data as $key => $value )
			$req .= $key . '=' . urlencode( stripslashes($value) ) . '&';

		// Cut the last '&'
		$req=substr($req,0,strlen($req)-1);
		return $req;
	}

	public function createTransaction($amount, $customer_id, $order_id) {
		$call_data = array(
			'request_type' => 'CreateTransaction',
			'gwlogin' => $this->config->get('quantum_gwlogin'),
			'vault_key' => $this->config->get('quantum_vault_key'),
			'amount' => $amount,
			'customer_id' => $customer_id,
			'process_type' => 'SALES',
			'transaction_type' => 'CREDIT',
			'order_id' => $order_id,
		);

		return $this->call($call_data, array('format' => 'array'));
	}

	public function call($data, $options = array('format' => 'json')) {
		$format = 'json';
		if ($options['format'] == 'array') {
			$format = $options['format'];
		}

		$api_endpoint = 'https://secure.quantumgateway.com/cgi/xml_requester.php';

		if ($data['request_type'] == 'ShowTransactionDetails') {
			$xmlData = array(
				'Authentication' => array(
					'GatewayLogin' => $data['gwlogin'],
					'GatewayKey'   => $data['restrict_key'],
				),
				'Request'        => array(
					'RequestType'   => $data['request_type'],
					'TransactionID' => $data['transaction_id'],
				),
			);
		} else if ($data['request_type'] == 'CreateTransaction') {
			$xmlData = array(
				'Authentication' => array(
					'GatewayLogin' => $data['gwlogin'],
					'GatewayKey'   => $data['vault_key'],
				),
				'Request'        => array(
					'RequestType'   => $data['request_type'],
					'ProcessType' => $data['process_type'],
					'TransactionType' => $data['transaction_type'],
					'Amount' => $data['amount'],
					'CustomerID' => $data['customer_id'],
					'Memo' => $data['order_id'],
				),
			);
		} else if ($data['request_type'] == 'ProcessSingleTransaction') {
			$xmlData = array(
				'Authentication' => array(
					'GatewayLogin' => $data['gwlogin'],
					'GatewayKey' => $data['restrict_key'],
				),
				'Request' => array(
					'RequestType' => $data['request_type'],
					'ProcessType' => $data['process_type'],
					'TransactionID' => $data['transaction_id'],
				),
			);
			if (isset($data['credit_card_number'])) {
				$xmlData['Request']['CreditCardNumber'] = $data['credit_card_number'];
			}
		} else {
			$xmlData = array (
				'Authentication' => array(
					'GatewayLogin' => $data['gwlogin'],
					'GatewayKey' => $data['restrict_key'],
				),
				'Request' => array(
					'RequestType' => $data['request_type'],
					'Status' => $data['status'],
					'TransactionDateBegin' => $data['date_begin'], //'2015-02-02',
					'TransactionDateEnd' => $data['date_end'], //'2015-02-05',
					'TransactionType' => $data['transaction_type'],
					'CustomerID' => isset($data['customer_id']) ? $data['customer_id'] : '',
					'PaymentType' => isset($data['payment_type']) ? $data['payment_type'] : '',
					'SettlementBatchID' => isset($data['settlement_batch_id']) ? $data['settlement_batch_id'] : '',
					'SettlementDateBegin' => isset($data['settlement_date_begin']) ? $data['settlement_date_begin'] : '',
					'SettlementDateEnd' => isset($data['settlement_date_end']) ? $data['settlement_date_end'] : '',
				),
			);
		}

		$xml = $this->assocArrayToXML('QGWRequest', $xmlData);

		$defaults = array(
			CURLOPT_POST => 1,
			CURLOPT_HEADER => 0,
			CURLOPT_URL => $api_endpoint,
			CURLOPT_USERAGENT => "Mozilla/5.0 (Windows; U; Windows NT 5.1; en-US; rv:1.8.1.1) Gecko/20061204 Firefox/2.0.0.1",
			CURLOPT_FRESH_CONNECT => 1,
			CURLOPT_RETURNTRANSFER => 1,
			CURLOPT_FORBID_REUSE => 1,
			CURLOPT_TIMEOUT => 0,
			CURLOPT_SSL_VERIFYPEER => 0,
			CURLOPT_SSL_VERIFYHOST => 0,
			CURLOPT_POSTFIELDS => "xml=" . $xml
		);

		$ch = curl_init();

		curl_setopt_array($ch, $defaults);

		if (!$result = curl_exec($ch)) {

			$log_data = array(
				'curl_error' => curl_error($ch),
				'curl_errno' => curl_errno($ch)
			);

			return false;
		}

		curl_close($ch);

		$result = str_replace(array("\n", "\r", "\t"), '', $result);
		$result =  trim(str_replace('"', "'", $result));
		$simpleXml = simplexml_load_string($result);

		if ($format == 'json') {
			$json = json_encode($simpleXml);
			return $json;
		} else if ($format == 'array') {
			return $this->xmlToArray($simpleXml);
		} else {
			return false;
		}
	}

	function assocArrayToXML($root_element_name,$ar) {
		$xml = new SimpleXMLElement("<?xml version=\"1.0\"?><{$root_element_name}></{$root_element_name}>");
		$f = create_function('$f,$c,$a','
            foreach($a as $k=>$v) {
                if(is_array($v)) {
                    $ch=$c->addChild($k);
                    $f($f,$ch,$v);
                } else {
                    $c->addChild($k,$v);
                }
            }');
		$f($f,$xml,$ar);
		return $xml->asXML();
	}

	function xmlToArray($xmlObject) {
		$result = array();
		foreach ((array) $xmlObject as $key => $value) {
			$result[$key] = (is_object($value)) ? $this->xmlToArray($value) : $value;
		}
		return $result;
	}
}
